<?php
/**
 * @file
 * Modal form für ISDN Portgruppen
 */
header('Content-Type: text/html; charset=ISO-8859-1');
chdir("../..");

include "./includes/variables.php";
include "./misc/database.php";
include("./misc/config_parameter.php");
$ba = new beroAri();
require_once ('./includes/lang.php');
require_once "./includes/isgwtelnet.php";
require_once "./includes/Helper/HelperPstn.php";
require_once "./includes/Helper/Helper.php";
require_once('/usr/local/www/berogui/includes/session.php');

$group = '"general"';
$query_comp = $ba->select("SELECT * FROM analog");
while ($entry = $ba->fetch_array($query_comp)) {
	if ($entry['gr'] != $_GET['gr'])
		$group .= ',' . '"' . $entry['gr'] . '"';
}
?>


<script type="text/javascript">
    var validator = $("#analog").validate({

        rules: {

            group: {
                required: true,
                specChar: true,
                checkBlank: true,
                compareName: [<?php echo $group; ?>]
            },
            clip: {
                required: function (element) {
                    return "FXO" == "<?php echo $_GET['opt']; ?>";
                }
            },
            'ports[]': {
                atLeastOnePort: true,
            }
        },
        highlight: function (element) {
            $(element).closest('.form-group').addClass('has-error');
        },
        unhighlight: function (element) {
            $(element).closest('.form-group').removeClass('has-error');
        }
    });

    function required() {
        if ("FXO" == "<?php echo $_GET['opt']; ?>") {
            addAsterisk("clip");
        } else {
            deleteAsterisk("clip");
        }
    }

    function overlapdial_show(val) {
        if (val) {
            $(".odt_empty_dad_tr").css("display","none");
            $(".odt_tr").css("display", "none");
        } else {
            $(".odt_empty_dad_tr").css("display","");
            $(".odt_tr").css("display", "");
        }
    }

    $(document).ready(function () {
        $('[data-toggle="tooltip"]').tooltip({placement: 'auto bottom', html: true, trigger: 'hover', container: 'body'});
        required();
        overlapdial_show(document.getElementById('overlap_dialing').checked);
        $('input[name="group"]').focus();
    });
	
	$('#analog-tab a').on('hide.bs.tab', function (e) {
			var valid = true;
			var tab=e.target.getAttribute('href');
			$(tab).find("input").each(function() {
				if (!validator.element(this) && valid) {
					valid = false;
				}
			});
			$(tab).find("select").each(function() {
				if (!validator.element(this) && valid) {
					valid = false;
				}
			});
			if (!valid)
				e.preventDefault();
		});
</script>
<?php

function fxo_call_ending_signal($ba, $gr) {
	if ($gr != "") {
		$query = $ba->select("select fxo_call_ending_signal from analog where gr='" . sqlite_escape_string($gr) . "'");
		while ($entry = $ba->fetch_array($query)) {
			$ret = "<fieldset>";
			$res = explode(",", $entry['fxo_call_ending_signal']);
			if (in_array("unobtainable", $res))
				$ret .= PSTN_UNOBTAINABLE_TONE_DIS . "<input type='checkbox' value='unobtainable' name='fxo_call_ending_signal[]' checked><br>";
			else
				$ret .= PSTN_UNOBTAINABLE_TONE_DIS . "<input type='checkbox' value='unobtainable' name='fxo_call_ending_signal[]'><br>";
			if (in_array("busy", $res))
				$ret .= PSTN_BUSY_TONE_DIS . "<span style='margin-left:42px;'><input type='checkbox' value='busy' name='fxo_call_ending_signal[]' checked></span>";
			else
				$ret .= PSTN_BUSY_TONE_DIS . "<span style='margin-left:42px;'><input type='checkbox' value='busy' name='fxo_call_ending_signal[]'></span>";
			$ret .= "</fieldset>";
		}
		return $ret;
	}else {
		return "<fieldset>" . PSTN_UNOBTAINABLE_TONE_DIS . "<input type='checkbox' value='unobtainable' name='fxo_call_ending_signal[]' checked><br>" . PSTN_BUSY_TONE_DIS .
			"<span style='margin-left:42px;'><input type='checkbox' value='busy' name='fxo_call_ending_signal[]'></span></fieldset>";
	}
}

if ($ba->get('gui_mode') == 'simple') {
	$simple_class = 'simple';
}
$config_values = array("from_pstn_src_setting", "analog_display_setting", "analog_oad_setting", "clir_on_oad", "ec", "ectl",);
?>
<div>
	<!-- Nav tabs -->
	<ul class='nav nav-tabs' role='tablist' id='analog-tab'>
		<li role='presentation' class='active'><a href='#settings' aria-controls='settings' role='tab' data-toggle='tab'>Settings</a></li>
		<li role='presentation'><a href='#config-string' aria-controls='config-string' role='tab' data-toggle='tab'>More</a></li>
	</ul>
	<form name='analog' id='analog' action='modules/Analog/analog_submit.php?opt=<? echo $_GET['opt']; ?>' method='POST' class='form-horizontal' accept-charset='ISO-8859-1'>
		<!-- you have to make these ones end as well -->
		<div class='tab-content'>
			<div role='tabpanel' class='tab-pane active' id='settings' style='padding-top:15px;'>
				<div class='form-group group' data-toggle='tooltip' title='<? echo ANALOG_GROUP_NAME; ?>'>
					<label for='group' class='col-sm-3 control-label'><? echo PSTN_NAME_DIS; ?></label>
					<div class='col-sm-8'>
						<input name='group' id='group' class='form-control input-sm' type='text' value='<? echo $_GET['gr']; ?>'>
					</div>
				</div>
				<div class='form-group ports[]'>
					<label for='ports[]' class='col-sm-3 control-label'><? echo PSTN_PORTS_DIS; ?></label>
					<div class='col-sm-8'>
						<div class='left'>
							<div> <? echo HelperPstn::title($ba, $_GET['gr'], 0); ?></div>
							<div> <? echo HelperPstn::ports($ba, $_GET['gr'], 0, 'analog'); ?></div>
						</div>
						<div class='left' style='margin-left:50px;'>
							<div> <? echo HelperPstn::title($ba, $_GET['gr'], 1); ?></div>
							<div> <? echo HelperPstn::ports($ba, $_GET['gr'], 1, 'analog'); ?></div>
						</div>
						<? if (Helper::getType() == 30) { ?>
						<div class='left' style='margin-left:50px;'>
							<div> <? echo HelperPstn::title($ba, $_GET['gr'], 2); ?></div>
							<div> <? echo HelperPstn::ports($ba, $_GET['gr'], 2, "analog"); ?></div>
						</div>
						<? } ?>
					</div>
				</div>
				<!--careful with the names, they don't match in Helper -->
				<div class='form-group odt_empty_dad_tr <? echo $simple_class; ?>'>
					<label for='odt_empty_dad' class='col-sm-3 control-label'><? echo PSTN_OVERLAPDIAL_TIMEOUT_EMPTY_DAD_DIS; ?></label>
					<div class='col-sm-8'>
						<div> <? echo HelperPstn::textfield($ba, $_GET['gr'], 'overlap_dial_timeout_empty_dad', 'analog', '15'); ?></div>
					</div>
				</div>
				<div class='form-group odt_tr <? echo $simple_class; ?>'>
					<label for='odt_empty' class='col-sm-3 control-label'><? echo PSTN_ODT_DIS; ?></label>
					<div class='col-sm-8'>
						<div> <? echo HelperPstn::textfield($ba, $_GET['gr'], 'overlap_dial_timeout', 'analog', '3'); ?></div>
					</div>
				</div>
				<div class='form-group overlap_dialing <? echo $simple_class; ?>' data-toggle='tooltip' title='<? echo ISDN_OVERLAPDIALING; ?>'>
					<label for='overlap_dialing' class='col-sm-3 control-label'><? echo PSTN_OVERLAP_DIALING_DIS; ?></label>
					<div class='col-sm-8'>
						<div> <? echo HelperPstn::checkbox($ba, $_GET['gr'], 'overlap_dialing', 'analog', "onchange='overlapdial_show(this.checked)'"); ?></div>
					</div>
				</div>
				<div class='form-group tones'>
					<label for='tones' class='col-sm-3 control-label'><? echo PSTN_TONES_DIS; ?></label>
					<div class='col-sm-8'>
						<div> <? echo HelperPstn::tones($ba, $_GET['gr'], 'analog'); ?></div>
					</div>
				</div>
				<div class='form-group clip' data-toggle='tooltip' title='<? echo ANALOG_CLIP; ?>'>
					<label for='clip' class='col-sm-3 control-label'><? echo PSTN_CLIP_DIS; ?></label>
					<div class='col-sm-8'>
						<div> <? echo HelperPstn::textfield($ba, $_GET['gr'], 'clip', 'analog'); ?></div>
					</div>
				</div>
				<div class='form-group cnip <? echo $simple_class; ?>' data-toggle='tooltip' title='<? echo ANALOG_CNIP; ?>'>
					<label for='cnip' class='col-sm-3 control-label'><? echo PSTN_CNIP_DIS; ?></label>
					<div class='col-sm-8'>
						<div> <? echo HelperPstn::textfield($ba, $_GET['gr'], 'cnip', 'analog'); ?></div>
					</div>
				</div>
				<div class='form-group chansel <? echo $simple_class; ?>' data-toggle='tooltip' title='<? echo PSTN_CHANSEL; ?>'>
					<label for='chansel' class='col-sm-3 control-label'><? echo PSTN_CHANSEL_DIS; ?></label>
					<div class='col-sm-8'>
						<div> <? echo HelperPstn::dropdown($ba, $_GET['gr'], 'chansel', 'analog', array('standard' => 'standard', 'random' => 'random', 'roundrobin' => 'roundrobin')); ?></div>
					</div>
				</div>
				<div class='form-group chansel_dir <? echo $simple_class; ?>'>
					<label for='chansel_dir' class='col-sm-3 control-label'><? echo PSTN_CHANSEL_DIR_DIS; ?></label>
					<div class='col-sm-8'>
						<div> <? echo HelperPstn::dropdown($ba, $_GET['gr'], 'chansel_dir', 'analog', array('ascending' => 'ascending', 'descending' => 'descending')); ?></div>
					</div>
				</div>
				<div class='form-group dialtone_digits' <? echo $simple_class; ?>'>
					<label for='dialtone_digits' class='col-sm-3 control-label'><? echo PSTN_DIALTONE_DIGITS_DIR_DIS; ?></label>
					<div class='col-sm-8'>
						<div> <? echo HelperPstn::textfield($ba, $_GET['gr'], 'dialtone_digits', 'analog', '0'); ?></div>
					</div>
				</div>
				<?php
				if ($_GET['opt'] == "FXO") {
					?>
					<div class='form-group fxo_connect' <? echo $simple_class; ?>'>
						<label for='fxo_connect' class='col-sm-3 control-label'><? echo PSTN_CONNECT_DIS; ?></label>
						<div class='col-sm-8'>
							<div> <? echo HelperPstn::dropdown($ba, $_GET['gr'], 'fxo_connect', 'analog', array('instant' => 'instant', 'polarity' => 'polarity')); ?></div>
						</div>
					</div>
					<div class='form-group fxo_wait_for_oad' <? echo $simple_class; ?>'>
						<label for='fxo_wait_for_oad' class='col-sm-3 control-label'><? echo PSTN_WAIT_FOR_OAD_DIS; ?></label>
						<div class='col-sm-8'>
							<div> <? echo HelperPstn::dropdown($ba, $_GET['gr'], 'fxo_wait_for_oad', 'analog', array('wait' => 'wait', 'dontwait' => 'dontwait')); ?></div>
						</div>
					</div>
					<div class='form-group fxo_dialtone_passthrough' <? echo $simple_class; ?>'>
						<label for='fxo_dialtone_passthrough' class='col-sm-3 control-label'><? echo PSTN_MWI_DIS; ?></label>
						<div class='col-sm-8'>
							<div> <? echo HelperPstn::dropdown($ba, $_GET['gr'], 'message_waiting_method', 'analog', array('stutter' => 'stutter', 'fsk' => 'fsk', 'off' => 'off')); ?></div>
						</div>
					</div>
					<div class='form-group fxo_call_ending_signal' <? echo $simple_class; ?>'>
						<label for='fxo_call_ending_signal' class='col-sm-3 control-label'><? echo PSTN_ANALOG_CALL_ENDING_SIGNAL_DIS; ?></label>
						<div class='col-sm-8'>
							<div> <? echo fxo_call_ending_signal($ba, $_GET['gr']); ?></div>
						</div>
					</div>
					<div class='form-group fxo_cid_detection_mode' <? echo $simple_class; ?>'>
						<label for='fxo_cid_detection_mode' class='col-sm-3 control-label'><? echo PSTN_ANALOG_CID_DETECTION_MODE_DIS; ?></label>
						<div class='col-sm-8'>
							<div> <? echo HelperPstn::dropdown($ba, $_GET['gr'], 'fxo_cid_detection_mode', 'analog', array('Bellcore' => 'Bellcore', 'ETSI-DTMF' => 'ETSI-DTMF', 'ETSI-DTMF-AR' => 'ETSI-DTMF-AFTER-RINGING')); ?></div>
						</div>
					</div>
					<?php
				}
				?>

				<?php if ($_GET['opt'] == "FXS") {
					?>
					<div class='form-group message_waiting_method' <? echo $simple_class; ?>'>
						<label for='message_waiting_method' class='col-sm-3 control-label'><? echo PSTN_MWI_DIS; ?></label>
						<div class='col-sm-8'>
							<div> <? echo HelperPstn::dropdown($ba, $_GET['gr'], 'message_waiting_method', 'analog', array('stutter' => 'stutter', 'fsk' => 'fsk', 'off' => 'off')); ?></div>
						</div>
					</div>
					<?php
				}
				?>
			</div>
			<div role='tabpanel' class='tab-pane' id='config-string' style='padding-top:20px;'>
				<div class="row ec ec_tail clir_on_oad <? echo $simple_class; ?>">
					<p class="lead text-center"><? echo DIALPLAN_CONFIGURATION_DIS; ?></p>
				</div>
				<div class='form-group analog <? echo $simple_class; ?>' data-toggle='tooltip' title='<? echo EC; ?>'>
					<label for='analog' class='col-sm-3 control-label'><? echo DIALPLAN_EC_DIS; ?></label>
					<div class='col-sm-8'>
						<? echo ec('analog'); ?>
					</div>
				</div>
				<div class='form-group analog <? echo $simple_class; ?>' data-toggle='tooltip' title='<? echo EC_TAIL; ?>'>
					<label for='analog' class='col-sm-3 control-label'><? echo DIALPLAN_EC_TAIL_LENGTH_DIS; ?></label>
					<div class='col-sm-8'>
						<? echo ec_tail('analog'); ?>
					</div>
				</div>
				<div class='form-group analog <? echo $simple_class; ?>'>
					<label for='analog' class='col-sm-3 control-label'><? echo DIALPLAN_CLIR_ON_CLIP_DIS; ?></label>
					<div class='col-sm-8'>
						<? echo clir_on_oad('analog'); ?>
					</div>
				</div>

				<?php
				if ($_GET['opt'] == "FXS") {
					?>
					<div class='form-group analog <? echo $simple_class; ?>' data-toggle='tooltip' title='<? echo FROM_PSTN_SRC_SETTING; ?>'>
						<label for='analog' class='col-sm-3 control-label'><? echo DIALPLAN_FROM_PSTN_SRC_SETTING_DIS; ?></label>
						<div class='col-sm-8'>
							<div> <? echo from_pstn_src_setting('analog'); ?></div>
						</div>
					</div>
					<?php
				}
				?>

				<?php
				if ($_GET['opt'] == "FXO") {
					?>
				<div class="row analog_oad_setting analog_display_setting <? echo $simple_class; ?>">
					<p class="lead text-center"><? echo DIALPLAN_CALLER_ID_MAPPING_DIS; ?></p>
				</div>
				<div class='form-group analog_oad_setting <? echo $simple_class; ?>'>
					<label for='analog_oad_setting' class='col-sm-3 control-label'><? echo DIALPLAN_ANALOG_CLIP_SETTING_DIS; ?></label>
					<div class='col-sm-8'>
						<? echo caller_id_mapping_pstn('analog_oad_setting', 'analog'); ?>
					</div>
				</div>
				<div class='form-group analog_display_setting <? echo $simple_class; ?>'>
					<label for='analog_display_setting' class='col-sm-3 control-label'><? echo DIALPLAN_ANALOG_CNIP_SETTING_DIS; ?></label>
					<div class='col-sm-8'>
						<? echo caller_id_mapping_pstn('analog_display_setting', 'analog'); ?>
					</div>
				</div>
					<?php
				}
				?>

				<div class="row failover_proxy failover_timeout <? echo $simple_class; ?>">
					<p class="lead text-center"><? echo DIALPLAN_OTHER_DIS; ?></p>
				</div>
				<div class='form-group addit_options <? echo $simple_class; ?>' data-toggle='tooltip' title='<? echo ADDIT_OPTIONS; ?>'>
					<label for='addit_options' class='col-sm-3 control-label'><? echo DIALPLAN_ADDITIONAL_CONFIG_DIS; ?></label>
					<div class='col-sm-8'>
						<textarea name='addit_options' id='addit_options' class='form-control' rows='5'></textarea>
					</div>
				</div>
				<div class='form-group addit_options <? echo $simple_class; ?>'>
					<label for='extra_tooltip' class='col-sm-3 control-label'><? echo DIALPLAN_ADDITIONAL_CONFIG_DOC_DIS; ?></label>
					<div class='col-sm-8'>
						<p id='extra_tooltip' class='form-control-static' style='height: 170px; overflow: auto; border: 1px solid #A31D26; resize:both;'></p>
					</div>
				</div>
				<div class="clearfix"></div>
			</div>
		<div class='text-center'><i><? echo REQUIRED_FIELDS; ?></i></div>
</div>
		<?php
		if (isset($_GET['gr'])) {
			HelperPstn::showdefmc($config_values, 'a', 'analog');
		} else {
			HelperPstn::show_confadd($config_values, 'a');
		}
		?>
		<br/>
		<input type='hidden' name='gr_upd' value='<? echo $_GET['gr']; ?>'>
			   <div class='text-center'>
			<input name='submit' class='btn btn-default' type='submit' value='<? echo BUTTON_SAVE; ?>' >
		</div>
	</form>
</div>

